package com.kingdee.eas.custom.jiuzhoutong.shuiyou;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.jiuzhoutong.utils.SYUtils;
import com.kingdee.eas.custom.shuiyou.registration.RegistrationInfoFactory;
import com.kingdee.eas.custom.shuiyou.registration.RegistrationInfoInfo;
import com.kingdee.eas.fi.arap.util.DBUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.web.handler.tax.taxUnit.TaxUnitListHandler;
import okhttp3.*;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Map;
import java.util.Properties;

public class TaxUnitListHandlerEx extends TaxUnitListHandler {
    private Properties propt = new Properties();
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.jiuzhoutong.shuiyou.TaxUnitListHandlerEx");

    /**
     * ҵע
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void businessAegistrationAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        String entrance = "com.kingdee.eas.custom.jiuzhoutong.shuiyou.TaxUnitListHandlerEx.businessAegistrationAction";
        logger.error("=========룺"+entrance+"==========");
        String id = request.getParameter("id");
        Context context = SHRContext.getInstance().getContext();
        SYUtils syUtils =null;
        Response sYResponse = null;
        Map<String, String> commonParameter = null;
        String postBody ="";
        try {
            logger.error("=====ȡϢ=====");
            this.propt.load(new FileInputStream(System.getProperty("EAS_HOME") + "/server/properties/sy/syConfig.properties"));
            syUtils = new SYUtils(propt);

            commonParameter = syUtils.getCommonParameter();//ȡ
            logger.error("======="+JSONObject.toJSONString(commonParameter)+"===========");

            logger.error("=======ȡ˰ҵϢ=====");
            TaxUnitInfo taxUnitInfo = TaxUnitFactory.getLocalInstance(context).getTaxUnitInfo(new ObjectUuidPK(id));
            String name = taxUnitInfo.getName();//ҵ
            String taxNumber = taxUnitInfo.getTaxNumber();//˰
            String areaCode = taxUnitInfo.getAreaCode();//
            logger.error("ҵƣ"+name);
            logger.error("˰ţ"+taxNumber);
            logger.error("룺"+areaCode);
            logger.error("==========================");


            logger.error("========== post================");
            OkHttpClient client = new OkHttpClient();
            String ip = propt.getProperty("ip");
            String url = ip+"/gateway/iit/declare/getCompanyRegisterInfo";
            logger.error("ַ"+url);
            postBody = "{\"qymc\":\""+name+"\",\"nsrsbh\":\""+taxNumber+"\",\"areaid\":\""+areaCode+"\"}";
            logger.error(""+postBody);
            logger.error(""+JSONObject.toJSONString(commonParameter));
            //gateway/iit/declare/getCompanyRegisterInfo
            RequestBody body = RequestBody.create(MediaType.parse("application/json"), postBody);
            Request sYRequest = new Request.Builder()
                    .url(url)
                    .post(body).headers(Headers.of(commonParameter))
                    .build();
             sYResponse = client.newCall(sYRequest).execute();
            if (sYResponse.isSuccessful()) {
                String responseData = sYResponse.body().string();
                logger.error("ز"+responseData);
                JSONArray jsonArray = JSONArray.parseArray(responseData);
                RegistrationInfoInfo registrationInfo ;
                if (jsonArray.size()>0){
                    logger.error("ɾԭеԱде");
                    String sql = "delete from CT_REG_RegistrationInfo";
                    DBUtil.execute(context,sql);
                }
                logger.error("дݣ");
                for (int i = 0; i < jsonArray.size(); i++) {
                    registrationInfo = new RegistrationInfoInfo();
                    JSONObject jsonObject = jsonArray.getJSONObject(i);
                    String djxhid = jsonObject.getString("djxhid");//	Ǽ

                    registrationInfo.setDjxhid(djxhid);
                    String qymc = jsonObject.getString("qymc");//	ҵ

                    registrationInfo.setQymc(qymc);
                    String frxm = jsonObject.getString("frxm");//	
                    registrationInfo.setFrxm(frxm);

                    String lxdh = jsonObject.getString("lxdh");//	ϵ绰
                    registrationInfo.setLxdh(lxdh);

                    String scjydz = jsonObject.getString("scjydz");//	Ӫַ
                    registrationInfo.setScjydz(scjydz);

                    String hymc = jsonObject.getString("hymc");//	ҵ
                    registrationInfo.setHymc(hymc);

                    String zgswjgmc = jsonObject.getString("zgswjgmc");//	˰
                    registrationInfo.setZgswjgmc(zgswjgmc);

                    String zgswjg = jsonObject.getString("zgswjg");//	˰ش
                    registrationInfo.setZgswjg(zgswjg);

                    String zgswjgskdm = jsonObject.getString("zgswjgskdm");//	˰־ƴ
                    registrationInfo.setZgswjgskdm(zgswjgskdm);

                    String zgswjgskmc = jsonObject.getString("zgswjgskmc");//	˰־
                    registrationInfo.setZgswjgskmc(zgswjgskmc);

                    String fbmba = jsonObject.getString("fbmba");//	Ƿֲű
                    registrationInfo.setFbmba(fbmba);

                    String smzh = jsonObject.getString("smzh");//	ʵ˺
                    registrationInfo.setSmzh(smzh);

                    String shxydm = jsonObject.getString("shxydm");//	ô
                    registrationInfo.setShxydm(shxydm);

                    String nsrsbm = jsonObject.getString("nsrsbm");//	˰ʶ
                    registrationInfo.setNsrsbm(nsrsbm);

                    String yzbm = jsonObject.getString("yzbm");//	
                    registrationInfo.setYzbm(yzbm);

                    String cwxm = jsonObject.getString("cwxm");//	
                    registrationInfo.setCwxm(cwxm);

                    String hydm = jsonObject.getString("hydm");//	ҵ
                    registrationInfo.setHydm(hydm);

                    String jjlxdm = jsonObject.getString("jjlxdm");//	ƴ
                    registrationInfo.setJjlxdm(jjlxdm);

                    String jjlxmc = jsonObject.getString("jjlxmc");//	
                    registrationInfo.setJjlxmc(jjlxmc);

                    String ssglydm = jsonObject.getString("ssglydm");//	˰չԱ
                    registrationInfo.setSsglydm(ssglydm);

                    String bsrxm = jsonObject.getString("bsrxm");//	˰
                    registrationInfo.setBsrxm(bsrxm);

                    String jdxzdm = jsonObject.getString("jdxzdm");//	ֵ
                    registrationInfo.setJdxzdm(jdxzdm);

                    String kjywrdm = jsonObject.getString("kjywrdm");//	۽˴
                    registrationInfo.setKjywrdm(kjywrdm);

                    String djrq = jsonObject.getString("djrq");//	Ǽ
                    registrationInfo.setDjrq(djrq);

                    String swjgdm = jsonObject.getString("swjgdm");//	˰ش
                    registrationInfo.setSwjgdm(swjgdm);

                    String swjgmc = jsonObject.getString("swjgmc");//	˰
                    registrationInfo.setSwjgmc(swjgmc);

                    String sfscjyqy = jsonObject.getString("sfscjyqy");//	ǷӪҵ
                    registrationInfo.setSfscjyqy(sfscjyqy);

                    String nsrztdm = jsonObject.getString("nsrztdm");//	˰״̬
                    registrationInfo.setNsrztdm(nsrztdm);

                    String nsrztmc = jsonObject.getString("nsrztmc");//	˰״̬
                    registrationInfo.setNsrztmc(nsrztmc);

                    RegistrationInfoFactory.getLocalInstance(context).save(registrationInfo);
                }
                logger.error("¼ɹӿ־");
                syUtils.interfaceLog(context,null,ip+"/gateway/iit/declare/getCompanyRegisterInfo"
                ,"ҵע",postBody,responseData,entrance,commonParameter.get("xReqNonce"));

            } else {
                logger.error("¼޲־");
                syUtils.interfaceLog(context,sYResponse.message(),ip+"/gateway/iit/declare/getCompanyRegisterInfo"
                        ,"ҵע",postBody,null,entrance,commonParameter!=null?commonParameter.get("xReqNonce"):null);
                System.out.println("Error Code:" + sYResponse.message());
            }

        } catch (BOSException e) {
            logger.error("¼BOSExceptionӿ־");
            syUtils.interfaceLog(context,e.getMessage(),propt.getProperty("ip")+"/gateway/iit/declare/getCompanyRegisterInfo"
                    ,"ҵע",postBody,null,entrance,commonParameter!=null?commonParameter.get("xReqNonce"):null);
            throw new RuntimeException(e);
        } catch (EASBizException e) {
            logger.error("¼ EASBizException ӿ־");
            syUtils.interfaceLog(context,e.getMessage(),propt.getProperty("ip")+"/gateway/iit/declare/getCompanyRegisterInfo"
                    ,"ҵע",postBody,null,entrance,commonParameter!=null?commonParameter.get("xReqNonce"):null);
            throw new RuntimeException(e);
        } catch (FileNotFoundException e) {
            logger.error("¼ FileNotFoundException ӿ־");
            syUtils.interfaceLog(context,e.getMessage(),propt.getProperty("ip")+"/gateway/iit/declare/getCompanyRegisterInfo"
                    ,"ҵע",postBody,null,entrance,commonParameter!=null?commonParameter.get("xReqNonce"):null);
            throw new RuntimeException(e);
        } catch (IOException e) {
            logger.error("¼ IOException ӿ־");
            syUtils.interfaceLog(context,e.getMessage(),propt.getProperty("ip")+"/gateway/iit/declare/getCompanyRegisterInfo"
                    ,"ҵע",postBody,null,entrance,commonParameter!=null?commonParameter.get("xReqNonce"):null);
            throw new RuntimeException(e);
        }
        logger.error("======================˳==================================");
    }



}
